Subject: Re: bug#67609: 29.1; (eglot-inlay-hints-mode -1) behaves surprisingly, does not work in cc-mode hooks

From: João Távora <[email-masked]>
Date: Sat, 16 Dec 2023 11:55:32 +0000

On Sat, Dec 16, 2023, 09:32 Eli Zaretskii <[email-masked]> wrote:

> > Cc: [email-masked]
> > From: Morgon Kanter <[email-masked]>
> > Date: Sun, 3 Dec 2023 14:37:42 -0500
> >
> > > > To reproduce, visit a C++ buffer in a project, run M-x eglot. Inlay
> > > > hints will appear. Kill and reopen the buffer. Inlay hints will
> > > > appear.
> > >
> > > To achieve your desired behaviour, read my advice in the last email,
> > > thanks.
> >
> > Fair enough. I understand now that the correct and expected way to
> > disable this is the way you have described. Since the behavior appears
> > surprising though, and it looks like the only such eglot-related mode
> > command is eglot-inlay-hints-mode, could something like this quote be
> > added to the manual for eglot-inlay-hints-mode?
> >
> > "Eglot will turn on eglot-inlay-hints-mode after setting up, which
> > happens after most mode hooks are run. To disable it, you should run
> > (eglot-inlay-hints-mode -1) in eglot-managed-mode-hook, rather than
> > your buffer's major mode hooks."
> >
> > This should hopefully stop bug reports like mine in the future.
>
> João, do we need to do anything here, or can this be closed now?
>

I mean to add something to the manual  (though not specifically for inlay
hints) that will help users connect the pieces of this puzzle more easily,
the there pieces being.

Eglot generally turns all supported things on by default
Eglot has a minor mode with a hook
Eglot functions called from lisp have no effect outside the minor mode.

João